/**
 * DO NOT EDIT
 *
 * This file was automatically generated by
 *   https://github.com/Polymer/gen-typescript-declarations
 *
 * To modify these typings, edit the source file(s):
 *   auth-methods-mixin.html
 */

declare namespace ArcBehaviors {


  /**
   * Contains a common properties and methods used in the Auth methods element set.
   *
   * Elements that implements this behavior may use `getSettings()` function to return an object
   * that will be passed to the `authorization-enabled` and `authorization-disabled` event.
   * Before sending this event it will try to collect settings data from this function. Whole object
   * will be passed to the event detail.
   */
  function AuthMethodsMixin<T extends new (...args: any[]) => {}>(base: T): T & AuthMethodsMixinConstructor;

  interface AuthMethodsMixinConstructor {
    new(...args: any[]): AuthMethodsMixin;
  }

  interface AuthMethodsMixin {

    /**
     * A start index for elements step counter.
     * Basic assumption is that this elements are used inside the
     * `authorization` panel which has the first step (auth type selector).
     * If the element is to be used as a standalone element then this
     * should be set to `0` (zero) so the number for the first step will be
     * `1`.
     * Basic and NTLM auth elements has only one step. Other elements, with
     * more complex structure has more steps.
     */
    stepStartIndex: number|null|undefined;

    /**
     * If true then the auth method will not render progress bar (stepper).
     */
    noSteps: boolean|null|undefined;

    /**
     * Setting passed to paper buttons.
     */
    noink: boolean|null|undefined;

    /**
     * Gets a oauth type by the elemnt name.
     * Possible values: 'basic', 'ntlm', 'oauth1', 'oauth2', 'digest', 'custom'
     * or undefined.
     */
    _getAuthType(): any;

    /**
     * Gathers data by calling `validate()` and `getSettings()` function and
     * dispatches `auth-settings-changed` custom event
     *
     * @param type Auth form type.
     * @returns Dispatched event
     */
    _notifySettingsChange(type: String|null): CustomEvent|null;

    /**
     * Extracts value from AMF property.
     *
     * @param model Property model
     */
    _getAmfValue(model: any[]|null): String|null|undefined;
  }
}
